import os, shutil
import memigui as g
from memigui import *
from mpkgenums import CanMsgType, EMMsgType, TouchEvent, EMNotifyType, EMEncEvent

# import inspect
# from pprint import *

# Main class which will be called from package manager
class pkgrunner():
  
  # Reference to the calling mpkg manager class 
  mpkgmanager=None
  msgBoxStd = None
  pkgTitleText = "XVAOS Update V2.20.D"

  def __init__(self, mgr) -> None:
    self.mpkgmanager = mgr
    mpkgmanager = self.mpkgmanager

    self.functions = {
      "CanID_90": self.OnEventEnc1, 
      "CanID_91": self.NotImplemented, 
      "CanID_92": self.NotImplemented, 
      "CanID_93": self.OnEventEnc4, 
      "CanID_90_0": self.runTask_Install, 
    }

    # -------------- Define Styles to be used beyond defaults -------------- 
    
    g.CTheme.SetNamedColor("MPMMsgBoxBorder",g.CTheme.ColorFromRGB(50,50,50))

    g.CTheme.SetNamedColor("BtnFg",g.CTheme.ColorFromRGB(0,0,255))
    g.CTheme.SetNamedColor("BtnFgAcc",g.CTheme.ColorFromRGB(16,16,64))
    g.CTheme.SetNamedColor("BtnBorder",g.CTheme.ColorFromRGB(255,0,0))
    g.CTheme.SetNamedColor("BtnBorderAcc",g.CTheme.ColorFromRGB(0,0,255))
    g.CTheme.SetNamedColor("BtnText",g.CTheme.ColorFromRGB(255,255,255))
    g.CTheme.SetNamedColor("BtnTextAcc",g.CTheme.ColorFromRGB(48,48,48))
    g.CTheme.SetNamedColor("ValLblBg", g.CTheme.ColorFromRGB(32, 32, 32))
    #g.CTheme.SetNamedColor("ValLblBorderAcc", g.CTheme.ColorFromRGB(192, 0, 0))
    g.CTheme.SetNamedColor("ValLblBorderAcc", g.CTheme.ColorFromRGB(90, 156, 162))
    g.CTheme.SetNamedColor("ValLblTitleText", g.CTheme.ColorFromRGB(164, 164, 164))
    g.CTheme.SetNamedColor("ValLblText", g.CTheme.ColorFromRGB(192, 192, 192))
    g.CTheme.SetNamedColor("ValLblTextAcc", g.CTheme.ColorFromRGB(255, 255, 255))

    # -------------- Screen play --------------
    if os.path.exists("bg.png"):
      self.bgimage=g.emImage(mpkgmanager.gui, emPOINT(0, 0), "bg.png", "./")
      bgimage=self.bgimage
      mpkgmanager.gui.AddElement(bgimage)
      bgimage.OnPaint()

    
    if os.path.exists("pkg.png"):
      self.rtimage=g.emImage(mpkgmanager.gui, emPOINT(530, 30), "pkg.png", "./")
      rtimage=self.rtimage
      mpkgmanager.gui.AddElement(rtimage)
      bgimage.OnPaint()

    self.msgBoxStd=g.emMessageBox(mpkgmanager.gui,"MPM",500,305,0x0,0x00ffffff,0x00ffffff)
    msgBoxStd = self.msgBoxStd
    msgBoxStd.show(emPOINT(10,10), self.pkgTitleText)
    msgBoxStd.OnPaint()
    msgBoxStd.setText("From Init")
    #self.LogMessage(f"Called with Package path {mpkgmanager.pkgPath}")

    
    # self.btnW1=emButton(mpkgmanager.gui, 1001, emPOINT(10, 330), 180, 60, g.CTheme.ColorFromRGB(16,16,64), g.CTheme.ColorFromRGB(0,0,255), g.CTheme.ColorFromRGB(255,255,255), True, 1, 0)
    # btnW1=self.btnW1
    # btnW1.SetText("BTN 1")
    # btnW1.setRepaint()
    # btnW1.OnPaint()
    # btnW1.SetFocus(True)
    # mpkgmanager.gui.AddElement(btnW1)

    # self.btnW2=emButton(mpkgmanager.gui, 1002, emPOINT(210, 330), 180, 60, g.CTheme.ColorFromRGB(16,16,64), g.CTheme.ColorFromRGB(0,0,255), g.CTheme.ColorFromRGB(255,255,255), True, 1, 0)
    # btnW2=self.btnW2
    # btnW2.SetText("BTN 2")
    # btnW2.setRepaint()
    # btnW2.OnPaint()
    # btnW2.SetFocus(True)
    # mpkgmanager.gui.AddElement(btnW2)

    # self.btnW3=emButton(mpkgmanager.gui, 1003, emPOINT(410, 330), 180, 60, g.CTheme.ColorFromRGB(16,16,64), g.CTheme.ColorFromRGB(0,0,255), g.CTheme.ColorFromRGB(255,255,255), True, 1, 0)
    # btnW3=self.btnW3
    # btnW3.SetText("BTN 3")
    # btnW3.setRepaint()
    # btnW3.OnPaint()
    # btnW3.SetFocus(True)
    # mpkgmanager.gui.AddElement(btnW3)

    # self.btnW4=emButton(mpkgmanager.gui, 1004, emPOINT(610, 330), 180, 60, g.CTheme.ColorFromRGB(16,16,64), g.CTheme.ColorFromRGB(0,0,255), g.CTheme.ColorFromRGB(255,255,255), True, 1, 0)
    # btnW4=self.btnW4
    # btnW4.SetText("BTN 4")
    # btnW4.setRepaint()
    # btnW4.OnPaint()
    # btnW4.SetFocus(True)
    # mpkgmanager.gui.AddElement(btnW4)

    self.vlblW2=emValueLabel(mpkgmanager.gui, "ActSel", 123, 0, emPOINT(10, 400), 180, 70, g.CTheme.ColorFromName("ValLblBg"), g.CTheme.ColorFromName("ValLblBorderAcc"), g.CTheme.ColorFromName("ValLblText"), g.CTheme.ColorFromName("ValLblTextAcc"), g.CTheme.ColorFromName("ValLblTitleText"))
    vlblW2 = self.vlblW2
    vlblW2.SetLabelText(" V2.20.D ", "", 12)
    vlblW2.AddEnumText("Install")
    # vlblW2.AddEnumText("Option 2")
    # vlblW2.AddEnumText("Option 3")
    vlblW2.SetFloatValue(0.0, 0)
    vlblW2.SetEncoderMode(8)
    vlblW2.SetChecked(True)
    vlblW2.SetFocus(True)
    vlblW2.SetEnabled(True)
    mpkgmanager.gui.AddElement(vlblW2)

    self.btnExit=emButton(mpkgmanager.gui, 9004, emPOINT(610, 405), 180, 60, g.CTheme.ColorFromRGB(16,16,64), g.CTheme.ColorFromRGB(0,0,255), g.CTheme.ColorFromRGB(255,255,255), True, 1, 0)
    btnExit=self.btnExit
    btnExit.SetText("Exit")
    btnExit.setRepaint()
    btnExit.OnPaint()
    btnExit.SetFocus(True)
    mpkgmanager.gui.AddElement(btnExit)


  def run(self):
    #self.LogMessage("Run function of pkgrunner called from mpkg manager object")
    self.LogMessage("-------- XVAOS V2.20.D Update installer -------")
    self.LogMessage(" ")
    self.LogMessage("Press Wheel 1 to start installation")
    self.LogMessage("Press Wheel 4 to Exit ")
    self.LogMessage(" ")
    self.LogMessage("-----------------------------------------------")
    self.LogMessage(" ")


  def OnGuiMessage(self, msg):

    try:
      em_msg_t = EMMsgType(msg.type)
    except:
      em_msg_t = EMMsgType.UNKNOWN

    try:
      touch_event = TouchEvent(msg.m_evt_type)
    except:
      touch_event = TouchEvent.UNKNOWN

    # print('MPKG Message received: msg-type:', em_msg_t, " event:", touch_event, " pData:", msg.pData, " arg:", msg.arg, " flag:", msg.flag, " param:", msg.param, " x,y:", msg.m_x, ",", msg.m_y)

    if em_msg_t == EMMsgType.EM_MSG_ON_BUTTON:
        self.BtnOnEventHandler(em_msg_t, msg.param)
  
  def LogMessage(self, text, single=False):
    msgBoxStd = self.msgBoxStd
    chunk_size = 47

    if single:
      msgBoxStd.setText(text)
      msgBoxStd.setRepaint()
      msgBoxStd.OnPaint()
    else:
      msgBoxStd.setText("")
      text_list = text.split("\n")

      for t in text_list:
        for i in range(0, len(t), chunk_size):
          chunk = t[i:i+chunk_size]
          msgBoxStd.AddLine(chunk)

  def ShowLogWindow(self, visibility):
    msgBoxStd = self.msgBoxStd
    mgr = self.mpkgmanager
    if visibility:
      msgBoxStd.show(emPOINT(10,10), self.pkgTitleText)
      msgBoxStd.setRepaint()
      msgBoxStd.OnPaint()
    else:
      msgBoxStd.hide()
      msgBoxStdRect = msgBoxStd.getClientRect()
      mgr.dc.BeginPaint(0, 0, 800, 480, False, False)
      mgr.dc.FillFrame(msgBoxStdRect.left, msgBoxStdRect.top, msgBoxStdRect.right, msgBoxStdRect.bottom ,g.CTheme.ColorFromRGB(0,0,0))
      mgr.dc.EndPaint()

  def OnCanMessage(self, id, byte_str, len):
    #print(f"MPKG Can Message received: id={id}, data={byte_str}, len={len}")

    try:
      f = f'CanID_{hex(id)[2:]}'
      self.functions[f](byte_str, len)
    except KeyError:
      print(f"No Function mapping for '{f}' found")
  
  def OnEventEnc1(self, data, len):
    try:
      enc_evt = EMEncEvent(data[0])
    except:
      enc_evt = EMEncEvent.UNKNOWN
    
    if enc_evt == EMEncEvent.PRESS:
      # self.LogMessage(f'F: {self.vlblW2.GetFloatValue()} I: {self.vlblW2.GetIntValue()}')
      try:
        f = f'CanID_90_{int(self.vlblW2.GetFloatValue())}'
        self.functions[f]()
      except KeyError:
        self.LogMessage(f"No Function mapping for '{f}' found")

    else:
      msg=g.tEM_Message()
      msg.type=EMMsgType.EM_MSG_ENCODER_EVENT.value
      msg.flag=data[0]
      msg.param=0
      self.vlblW2.OnMessage(msg)

  def OnEventEnc4(self, data, len):
    try:
      enc_evt = EMEncEvent(data[0])
    except:
      enc_evt = EMEncEvent.UNKNOWN
    
    if enc_evt == EMEncEvent.PRESS:
      # self.LogMessage(f'F: {self.vlblW2.GetFloatValue()} I: {self.vlblW2.GetIntValue()}')
      self.OnExit()

  def OnExit(self):
    import sys
    self.mpkgmanager.tPT.stop()
    sys.exit()

  def runTask_Install(self):
    xvaos_path = "/usr/bin/emi/xvaos/MD9XXOS1"
    
    self.LogMessage("Install XVAOS Update V2.20.D")

    # Update XVAOS 
    if os.path.exists("MD9XXOS1"):

      self.LogMessage("Copy XVAOS Files ...", True)

      shutil.copy2('MD9XXOS1',  xvaos_path)
      shutil.chown(xvaos_path, "emios", "emios")
      os.chmod(xvaos_path, 0o755)
      self.LogMessage("XVAOS update ok")

    else:
      self.LogMessage("ERROR: Update file not found")

    # Update GUI Data    
    if os.path.exists("gui.dat"):
      guibasepath = "/usr/share/emi/gui/"
      self.LogMessage("Update GUI Data ...", True)

      shutil.unpack_archive("gui.dat", guibasepath, "gztar")
      self.recursive_chown(guibasepath, "emios", "emios")
      self.recursive_chmod(guibasepath, 0o755, 0o644)

      self.LogMessage("Update GUI Data ... ok")

    else:
      self.LogMessage("ERROR: Update Gui Data file not found")

    # Update resources    
    if os.path.exists("ressources.dat"):
      resbasepath="/var/lib/emi/working/"

      self.LogMessage("Update ressource Data ...", True)

      shutil.unpack_archive("ressources.dat", resbasepath, "gztar")
      self.recursive_chown(resbasepath, "emios", "emios")
      self.recursive_chmod(resbasepath, 0o770, 0o660)

      self.LogMessage("Update ressource Data ... ok")

    else:
      self.LogMessage("ERROR: Update ressource data file not found")

  def recursive_chown(self, path, user, group):
    for dirpath, dirnames, filenames in os.walk(path):
      shutil.chown(dirpath, user, group)
      for filename in filenames:
        shutil.chown(os.path.join(dirpath, filename), user, group)


  def recursive_chmod(self, path, dirperm, fileperm):
    for dirpath, dirnames, filenames in os.walk(path):
      os.chmod(dirpath, dirperm)
      for filename in filenames:
        os.chmod(os.path.join(dirpath, filename), fileperm)

  # Common 'Not Implemented' for CAN messages
  def NotImplemented(self, data, len):
    print(f"Not implemented")

  # Button / Label 'click' events
  def BtnOnEventHandler(self, event, btnid):
    btn = {
      # 1001: self.btnW1,
      # 1002: self.btnW2,
      # 1003: self.btnW3,
      # 1004: self.btnW4,
      9004: self.btnExit
    }
    btn[btnid].SetChecked(False)
    # if btnid == 1001:
    #  self.runTask004(1,4)
    # elif btnid == 1002:
    #  self.runTask004(1,2)
    # elif btnid == 1003:
    #  self.runTask004(2,3)
    # elif btnid == 1004:
    #  self.runTask004(3,4)
    #elif btnid == 9004:
    if btnid == 9004:
      self.OnExit()


